/*=============================================================================
	exFMP4.dllgAPI
=============================================================================*/
#pragma once
#include	"fmp32_api.h"

namespace exFMP4 {

/*-----------------------------------------------------------------------------
	ANZXNX
-----------------------------------------------------------------------------*/
	class FUNC {
	  public:
		enum {								// t@NV
			GET_COMMENT = 1,				// ȃf[^Rg擾
			GET_SYNC = 2,					// ȃf[^VNJE^擾
			GET_DRIVER = 3,					// hCo
			GET_FILEPATH = 4,				// tt@C擾
		};

		// hCo
		static const DWORD DRIVER_FMP		= 0x00000001;
		static const DWORD DRIVER_PPZ8		= 0x00000002;
		static const DWORD DRIVER_PDZFZ8X	= 0x00000004;

		// 擾t@C
		static const int FILE_MUSIC			= 0;
		static const int FILE_PVI			= 1;
		static const int FILE_PPZ			= 2;

		// Rgobt@(max 16K)
		static const int COMMENT_SIZE		= 16*1024;

	  public:
		FUNC::FUNC(void);
		char* GetComment(void);
		int GetSyncCounter(void);
		DWORD GetDriverInfo(void);
		char* GetFilePath(int);

	  private:
		FMP32::FUNC* hFMP7;
		char CommentBuff[COMMENT_SIZE +1];
		char FilePath[_MAX_PATH +1];
	};

/*-----------------------------------------------------------------------------
	gL
-----------------------------------------------------------------------------*/
	namespace SHM {
		// GUID {6979673D-CD39-4ca5-A3BA-CA164AC27E1A}
		static const GUID GUID = 
			{ 0x6979673d, 0xcd39, 0x4ca5,
				{ 0xa3, 0xba, 0xca, 0x16, 0x4a, 0xc2, 0x7e, 0x1a }
			};

		// Ήp[g
		static const int PARTS_FM		= 6;
		static const int PARTS_SSG		= 3;
		static const int PARTS_ADPCM	= 1;
		static const int PARTS_RHYTHM	= 6;
		static const int PARTS_FMEX		= 3;
		static const int PARTS_ALL		= (PARTS_FM +
										   PARTS_SSG +
										   PARTS_ADPCM +
										   PARTS_RHYTHM +
										   PARTS_FMEX);

		// p[g[h
		static const BYTE EX_MODE_NON	= 0x00;		// gp
		static const BYTE EX_MODE_FM	= 0x01;		// FM
		static const BYTE EX_MODE_FMEX	= 0x02;		// FM(C-EX)
		static const BYTE EX_MODE_SSG	= 0x03;		// SSG
		static const BYTE EX_MODE_R_BD	= 0x04;		// Y(oXh)
		static const BYTE EX_MODE_R_SD	= 0x05;		// Y(XlAh)
		static const BYTE EX_MODE_R_CYM	= 0x06;		// Y(Vo)
		static const BYTE EX_MODE_R_HAT	= 0x07;		// Y(nCnbg)
		static const BYTE EX_MODE_R_TOM	= 0x08;		// Y(^)
		static const BYTE EX_MODE_R_RIM	= 0x09;		// Y(Vbg)
		static const BYTE EX_MODE_ADPCM	= 0x0a;		// ADPCM
		static const BYTE EX_MODE_PPZ8	= 0x0b;		// PCM(PPZ8)
		static const BYTE EX_MODE_PDZF	= 0x0c;		// PCM(PDZF)

		// LFO
		static const WORD EX_LFOV0		= 0x0001;	// ru[g#0(MP)
		static const WORD EX_LFOV1		= 0x0002;	// ru[g#1(MQ)
		static const WORD EX_LFOV2		= 0x0004;	// ru[g#2(MR)
		static const WORD EX_LFOT		= 0x0008;	// g
		static const WORD EX_LFOW		= 0x0010;	// E
		static const WORD EX_LFOE		= 0x0020;	// GR[
		static const WORD EX_LFOH		= 0x0040;	// n[hEFA

		// g񃏁[N\
#pragma pack(1)
		typedef struct tEX {
			BYTE	TimerB;					// TimerBl
			BYTE	Mode[PARTS_ALL];		// ڍ( EX_MODEQ)
			BYTE	ModeIdx[PARTS_ALL];		// CfbNX
			BYTE	Vol[PARTS_ALL];			// ʒl
			BYTE	Pan[PARTS_ALL];			// p[0-3]/[1-9]
			WORD	StatusLFO[PARTS_ALL];	// LFO( EX_LFOQ)
		} EX, *PEX;
#pragma pack()
	};
};
