/*=============================================================================
	exS98P.dllgAPI
=============================================================================*/
#pragma once
#include	"fmp32_api.h"

namespace exS98P {

/*-----------------------------------------------------------------------------
	ANZXNX
-----------------------------------------------------------------------------*/
	class FUNC {
	  public:
		enum {								// t@NV
			GET_COMMENT = 1,				// ȃf[^Rg擾
			GET_DRIVER = 2,					// hCo
			GET_FILEPATH = 3,				// tt@C擾
			GET_DATAINFO = 4,				// tf[^
			GET_OPNAMIX = 5,				// OPNA~LT[l
		};
		// f[^
		enum {
			DATA_CHIP = 1,					// 
			DATA_SOUNDSYSTEM = 2,			// VXe
			DATA_FREQ = 3,					// 쓮g
		};

		// hCo
		static const DWORD DRIVER_S98P		= 0x00000001;
		static const DWORD DRIVER_C86CTL	= 0x00000002;
		static const DWORD DRIVER_IOGIMIC	= 0x00000004;
		static const DWORD DRIVER_IF_MIDI	= 0x00000100;
		static const DWORD DRIVER_IF_HID	= 0x00000200;
		static const DWORD DRIVER_IF_WINSUB	= 0x00000400;

		// 擾t@C
		static const int FILE_MUSIC			= 0;

		// Rgobt@(max 1K)
		static const int COMMENT_SIZE		= 1024;

		// VXe
		static const int MAX_SOUNDSYSTEM	= 32;

	  public:
		FUNC::FUNC(void);
		char* GetComment(void);
		DWORD GetDriverInfo(int);
		LPWSTR GetFilePath(int);
		LPWSTR GetDataInfo(int,DWORD*);
		int GetMixerOPNA(void);

	  private:
		FMP32::FUNC* hFMP7;
		char CommentBuff[COMMENT_SIZE +1];
		WCHAR FilePath[_MAX_PATH +1];
		WCHAR SoundSystem[MAX_SOUNDSYSTEM +1];
	};

/*-----------------------------------------------------------------------------
	gL
-----------------------------------------------------------------------------*/
	namespace SHM {
		// GUID {FA6A6D1D-C1FD-407e-A485-1C42D2257E8A}
		static const GUID GUID = 
			{ 0xfa6a6d1d, 0xc1fd, 0x407e,
				{ 0xa4, 0x85, 0x1c, 0x42, 0xd2, 0x25, 0x7e, 0x8a }
			};

		// Ήp[g
		static const int PARTS_ALL		= 23;

		// p[g[h
		static const BYTE EX_MODE_NON	= 0x00;		// gp
		static const BYTE EX_MODE_FM	= 0x01;		// FM(OPNA/OPM)
		static const BYTE EX_MODE_SSG	= 0x02;		// SSG
		static const BYTE EX_MODE_R_BD	= 0x03;		// Y(oXh)
		static const BYTE EX_MODE_R_SD	= 0x04;		// Y(XlAh)
		static const BYTE EX_MODE_R_CYM	= 0x05;		// Y(Vo)
		static const BYTE EX_MODE_R_HAT	= 0x06;		// Y(nCnbg)
		static const BYTE EX_MODE_R_TOM	= 0x07;		// Y(^)
		static const BYTE EX_MODE_R_RIM	= 0x08;		// Y(Vbg)
		static const BYTE EX_MODE_ADPCM	= 0x09;		// ADPCM
		static const BYTE EX_MODE_FM2	= 0x0a;		// FM(OPL 2op)
		static const BYTE EX_MODE_FM4	= 0x0b;		// FM(OPL 4op)

		// g񃏁[N\
#pragma pack(1)
		typedef struct tEX {
			BYTE	Mode[PARTS_ALL];		// ڍ( EX_MODEQ)
			BYTE	Pan[PARTS_ALL];			// p[0-3]
			BYTE	Vol[PARTS_ALL];			// [0-127]/[0-15]
		} EX, *PEX;
#pragma pack()
	};
};
