/*=============================================================================
	FMP7JAPI
=============================================================================*/
#include	<windows.h>
#include	<string>
#include	"fmp7_api.h"

/*-----------------------------------------------------------------------------
	AvP[V
-----------------------------------------------------------------------------*/
const LPWSTR FMP7API::APPNAME = L"FMP7";

/*-----------------------------------------------------------------------------
	G[bZ[W
-----------------------------------------------------------------------------*/
const FMP7API::MSGTBL FMP7API::ErrMSG[] = {
	{ FMP32::ERR::NON_ERROR,			L"I" },
	{ FMP32::ERR::FMP_NOT_FOUND,		L"FMP7܂" },
	{ FMP32::ERR::BUSY,					L"FMP7wavet@Co͂ɂ胍bNĂ܂" },
	{ FMP32::ERR::OPEN_PROC,			L"ĂяovZXANZXG[" },
	{ FMP32::ERR::WRITE_MEMORY,			L"݃G[" },
	{ FMP32::ERR::READ_MEMORY,			L"ǂݍ݃G[" },
	{ FMP32::ERR::WORKSIZE_NOMATCH,		L"[NTCY܂" },
	{ FMP32::ERR::WORKSIZE_SHORT,		L"[NTCYsĂ܂" },
	{ FMP32::ERR::PARAM_RANGE,			L"p[^w͈̓G[" },
	{ FMP32::ERR::PART_RANGE,			L"p[gԍwG[" },
	{ FMP32::ERR::SEEK_RANGE,			L"V[Nw͈̓G[" },
	{ FMP32::ERR::COPY_SIZE_OVER,		L"ő像[NTCYI[o[" },
	{ FMP32::ERR::DRIVER_NOT_READY,		L"w艉thCo͖Nł" },

	{ NULL, NULL }
};

/*-----------------------------------------------------------------------------
	O[oϐ
-----------------------------------------------------------------------------*/
static FMP7API hHandle;

/*-----------------------------------------------------------------------------
	ANZXnh擾
-----------------------------------------------------------------------------*/
FMP32::FUNC*
GetFMP7Instance(
	void
) {
	return(&hHandle);
}

/*-----------------------------------------------------------------------------
	RXgN^
-----------------------------------------------------------------------------*/
FMP7API::FMP7API(
	void
) {
	dwPID = GetCurrentProcessId();
	dwLastError = FMP32::ERR::NON_ERROR;
}

/*-----------------------------------------------------------------------------
	o[W擾
-----------------------------------------------------------------------------*/
BOOL
FMP7API::GetVersion(
	int* system,
	int* major,
	int* minor
) {
	DWORD ver[3];
	if(! Send(API::GETVERSION, 0, (BYTE*)ver, sizeof(DWORD) *3))
		return(FALSE);

	if(system)
		*system = ver[0];
	if(major)
		*major = ver[1];
	if(minor)
		*minor = ver[2];

	return(TRUE);
}

/*-----------------------------------------------------------------------------
	JL[NTCY擾
-----------------------------------------------------------------------------*/
BOOL
FMP7API::GetWorkSize(
	int* global,
	int* part
) {
	DWORD size[2];
	if(! Send(API::GETWORKSIZE, 0, (BYTE*)size, sizeof(DWORD) *2))
		return(FALSE);

	if(global)
		*global = size[0];
	if(part)
		*part = size[1];

	return(TRUE);
}

/*-----------------------------------------------------------------------------
	JL[NTCY擾
-----------------------------------------------------------------------------*/
BOOL
FMP7API::GetWorkSize(
	int* global,
	int* part,
	int* ex
) {
	DWORD size[3];
	if(! Send(API::GETWORKSIZE, 0, (BYTE*)size, sizeof(DWORD) *3))
		return(FALSE);

	if(global)
		*global = size[0];
	if(part)
		*part = size[1];
	if(ex)
		*ex = size[2];

	return(TRUE);
}

/*-----------------------------------------------------------------------------
	ȃt@CpX擾
-----------------------------------------------------------------------------*/
int
FMP7API::GetPlayFilename(
	LPWSTR text,
	int maxlen
) {
	return(GetTextData(text, maxlen, TEXT::FILENAME));
}

/*-----------------------------------------------------------------------------
	ȃf[^擾
-----------------------------------------------------------------------------*/
int
FMP7API::GetMusicTitle(
	LPWSTR text,
	int maxlen
) {
	return(GetTextData(text, maxlen, TEXT::TITLE));
}

int
FMP7API::GetMusicCreator(
	LPWSTR text,
	int maxlen
) {
	return(GetTextData(text, maxlen, TEXT::CREATOR));
}

int
FMP7API::GetMusicComposer(
	LPWSTR text,
	int maxlen
) {
	return(GetTextData(text, maxlen, TEXT::COMPOSER));
}

int
FMP7API::GetMusicComment(
	LPWSTR text,
	int maxlen
) {
	return(GetTextData(text, maxlen, TEXT::COMMENT));
}

/*-----------------------------------------------------------------------------
	擾ʏ
-----------------------------------------------------------------------------*/
int
FMP7API::GetTextData(
	LPWSTR text,
	int maxlen,
	int type
) {
	if(text == NULL) {
		DWORD len;
		if(Send(API::GETTEXTLEN,
				type,
				(BYTE*)&len,
				sizeof(DWORD)))
			return(len);
	} else {
		if(Send(API::GETTEXT,
				type,
				(BYTE*)text,
				maxlen *sizeof(WCHAR)))
			return(lstrlen(text));
	}
	return(-1);
}

/*-----------------------------------------------------------------------------
	ȓǂݍ
-----------------------------------------------------------------------------*/
BOOL
FMP7API::MusicLoad(
	LPWSTR filename
) {
	return(Send(API::MUSICLOAD,
				LOAD::ONLY,
				(BYTE*)filename,
				(lstrlen(filename) +1) *sizeof(WCHAR)));
}

/*-----------------------------------------------------------------------------
	ȉt
-----------------------------------------------------------------------------*/
BOOL
FMP7API::MusicPlay(
	LPWSTR filename
) {
	return(Send(API::MUSICLOAD,
				LOAD::PLAY,
				(BYTE*)filename,
				(lstrlen(filename) +1) *sizeof(WCHAR)));
}

/*-----------------------------------------------------------------------------
	ȓǂݍ
-----------------------------------------------------------------------------*/
BOOL
FMP7API::MusicLoad(
	BYTE* data,
	int size
) {
	return(Send(API::MUSICLOAD2,
				LOAD::ONLY,
				data,
				size));
}

/*-----------------------------------------------------------------------------
	ȉt
-----------------------------------------------------------------------------*/
BOOL
FMP7API::MusicPlay(
	BYTE* data,
	int size
) {
	return(Send(API::MUSICLOAD2,
				LOAD::PLAY,
				data,
				size));
}

/*-----------------------------------------------------------------------------
	ȉtJn
-----------------------------------------------------------------------------*/
BOOL
FMP7API::MusicPlay(
	void
) {
	return(Send(API::MUSICPLAY, 0));
}

/*-----------------------------------------------------------------------------
	ȉt~
-----------------------------------------------------------------------------*/
BOOL
FMP7API::MusicStop(
	void
) {
	return(Send(API::MUSICSTOP, 0));
}

/*-----------------------------------------------------------------------------
	ȉtf
-----------------------------------------------------------------------------*/
BOOL
FMP7API::MusicPause(
	void
) {
	return(Send(API::MUSICPAUSE, 0));
}

/*-----------------------------------------------------------------------------
	tF[hAEg
-----------------------------------------------------------------------------*/
BOOL
FMP7API::MusicFadeOut(
	int para
) {
	return(Send(API::MUSICFADE, para));
}

/*-----------------------------------------------------------------------------
	}XNw
-----------------------------------------------------------------------------*/
BOOL
FMP7API::SetMask(
	int part,
	BOOL mask
) {
	DWORD data[2];
	data[0] = part;
	data[1] = mask;
	return(Send(API::SETMASK,
				MASK::SINGLE_PART,
				(BYTE*)data,
				sizeof(DWORD)*2));
}

/*-----------------------------------------------------------------------------
	}XNw
-----------------------------------------------------------------------------*/
BOOL
FMP7API::SetMask(
	BYTE* mask
) {
	return(Send(API::SETMASK,
				MASK::ALL_PART,
				mask,
				128));
}

/*-----------------------------------------------------------------------------
	V[Nʒuw
-----------------------------------------------------------------------------*/
BOOL
FMP7API::SetSeek(
	DWORD seek
) {
	return(Send(API::SETSEEK, 0, (BYTE*)&seek, sizeof(DWORD)));
}

/*-----------------------------------------------------------------------------
	gAPIR[
-----------------------------------------------------------------------------*/
BOOL
FMP7API::CallExAPI(
	GUID guid,
	DWORD func,
	DWORD ex1,
	DWORD ex2,
	void* ex3,
	int ex3_size,
	int* ret
) {
	if(ex3_size > 65535) {
		dwLastError = FMP32::ERR::COPY_SIZE_OVER;
		return(FALSE);
	}
	EXAPIINFO* info = (EXAPIINFO*)new BYTE[sizeof(EXAPIINFO) -1 +ex3_size];

	info->guid = guid;
	info->func = func;
	info->ex1 = ex1;
	info->ex2 = ex2;
	info->ex3_size = ex3_size;
	if(ex3)
		CopyMemory(info->ex3, ex3, ex3_size);

	if(! Send(
		API::CALLEXAPI,
		0,
		(BYTE*)info,
		sizeof(EXAPIINFO) -1 +ex3_size
		)) {
		delete [] info;
		return(FALSE);
	}

	if(ret)
		*ret = info->ret;
	if(ex3)
		CopyMemory(ex3, info->ex3, ex3_size);

	delete [] info;

	return(TRUE);
}

/*-----------------------------------------------------------------------------
	APIM
-----------------------------------------------------------------------------*/
BOOL
FMP7API::Send(
	int api,
	int para,
	BYTE* data,
	int size
) {
	HWND hwnd;
	COPYDATASTRUCT cd;
	APIINFO info;

	info.pid = dwPID;
	info.size = size;
	info.data = data;
	cd.dwData = MAKELONG(api, para);
	cd.cbData = sizeof(APIINFO);
	cd.lpData = &info;

	try {
		if(NULL == (hwnd = FindWindow(APPNAME, NULL)))
			throw(FMP32::ERR::FMP_NOT_FOUND);

		LRESULT ret = SendMessage(hwnd, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cd);
		if(ret != FMP32::ERR::NON_ERROR)
			throw((FMP32::ERR::D)ret);
	}
	catch(FMP32::ERR::D err) {
		dwLastError = err;
		return(FALSE);
	}

	return(TRUE);
}

/*-----------------------------------------------------------------------------
	APIM (APIINFOȗ^)
-----------------------------------------------------------------------------*/
BOOL
FMP7API::Send(
	int api,
	int para
) {
	HWND hwnd;
	COPYDATASTRUCT cd;

	cd.dwData = MAKELONG(api, para);
	cd.cbData = 0;
	cd.lpData = NULL;

	try {
		if(NULL == (hwnd = FindWindow(APPNAME, NULL)))
			throw(FMP32::ERR::FMP_NOT_FOUND);

		LRESULT ret = SendMessage(hwnd, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cd);
		if(ret != FMP32::ERR::NON_ERROR)
			throw((FMP32::ERR::D)ret);
	}
	catch(FMP32::ERR::D err) {
		dwLastError = err;
		return(FALSE);
	}

	return(TRUE);
}

/*-----------------------------------------------------------------------------
	G[ԍ擾
-----------------------------------------------------------------------------*/
DWORD
FMP7API::GetLastError(
	void
) {
	if(dwLastError == FMP32::ERR::FILE_LOAD) {
		DWORD code;
		if(Send(API::GETDETAIL, 0, (BYTE*)&code, sizeof(DWORD)))
			return(code);
	}

	return(dwLastError);
}

/*-----------------------------------------------------------------------------
	G[bZ[W擾
-----------------------------------------------------------------------------*/
int
FMP7API::GetErrorMessage(
	LPWSTR text,
	int maxlen
) {
	if(dwLastError == FMP32::ERR::FILE_LOAD)
		return(GetTextData(text, maxlen, TEXT::DETAILERRMSG));

	int len = 0;
	for(MSGTBL* p = (MSGTBL*)ErrMSG; p->pMess != NULL; p++) {
		if(p->Code == dwLastError) {
			if(text) {
				lstrcpyn(text, p->pMess, maxlen);
				len = lstrlen(text);
			} else {
				len = lstrlen(p->pMess);
			}
		}
	}

	return(len);
}

/*-----------------------------------------------------------------------------
	tf[^gqXg擾

 DRIVER1|*.EXT1(;*.EXT2...) (,DRIVER2|*.EX1(;EXT2...) ...)
-----------------------------------------------------------------------------*/
int
FMP7API::GetExtList(
	LPWSTR text,
	int maxlen,
	BOOL filter
) {
	WCHAR ext[1024 +1];
	if(-1 == GetTextData(ext, 1024, TEXT::EXTLIST))
		return(-1);

	int len = lstrlen(ext);
	if(filter) {
		std::wstring buff;
		buff.clear();
		for(LPWSTR s = ext; *s != 0x00; s++) {
			if(*s == L',') {
				buff += L"\n";
				continue;
			}

			if(*s == L'|') {
				buff += L"` (";

				for(LPWSTR p = s +1; *p != 0x00 && *p != L','; p++) {
					if(*p == L';') {
						buff += L'/';
					} else {
						buff += *p;
					}
				}
				buff += L")\n";
				continue;
			}

			buff += *s;
		}
		buff += L"\n";

		lstrcpy(ext, buff.c_str());

		// \n\0ɒu
		for(LPWSTR p = ext; *p != 0x00; p++)
			if(*p == '\n')
				*p = '\0';
		len = buff.size();
	}

	if(text != NULL) {
		if(len > maxlen)
			len = maxlen;
		memcpy(text, ext, (len +1) *2);
	}

	return(len);
}
